/* sudoku-game.c generated by valac 0.44.7, the Vala compiler
 * generated from sudoku-game.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <glib.h>
#include <gee.h>
#include <float.h>
#include <math.h>
#include <string.h>

#define TYPE_SUDOKU_GAME (sudoku_game_get_type ())
#define SUDOKU_GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_GAME, SudokuGame))
#define SUDOKU_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_GAME, SudokuGameClass))
#define IS_SUDOKU_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_GAME))
#define IS_SUDOKU_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_GAME))
#define SUDOKU_GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_GAME, SudokuGameClass))

typedef struct _SudokuGame SudokuGame;
typedef struct _SudokuGameClass SudokuGameClass;
typedef struct _SudokuGamePrivate SudokuGamePrivate;

#define TYPE_SUDOKU_BOARD (sudoku_board_get_type ())
#define SUDOKU_BOARD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_BOARD, SudokuBoard))
#define SUDOKU_BOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_BOARD, SudokuBoardClass))
#define IS_SUDOKU_BOARD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_BOARD))
#define IS_SUDOKU_BOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_BOARD))
#define SUDOKU_BOARD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_BOARD, SudokuBoardClass))

typedef struct _SudokuBoard SudokuBoard;
typedef struct _SudokuBoardClass SudokuBoardClass;
typedef enum  {
	GAME_MODE_PLAY,
	GAME_MODE_CREATE
} GameMode;

#define TYPE_GAME_MODE (game_mode_get_type ())

#define SUDOKU_GAME_TYPE_UNDO_ITEM (sudoku_game_undo_item_get_type ())
typedef struct _SudokuGameUndoItem SudokuGameUndoItem;
enum  {
	SUDOKU_GAME_0_PROPERTY,
	SUDOKU_GAME_PAUSED_PROPERTY,
	SUDOKU_GAME_NUM_PROPERTIES
};
static GParamSpec* sudoku_game_properties[SUDOKU_GAME_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
typedef struct _SudokuBoardPrivate SudokuBoardPrivate;

#define TYPE_COORD (coord_get_type ())
typedef struct _Coord Coord;
#define _sudoku_game_undo_item_free0(var) ((var == NULL) ? NULL : (var = (sudoku_game_undo_item_free (var), NULL)))
enum  {
	SUDOKU_GAME_TICK_SIGNAL,
	SUDOKU_GAME_PAUSED_CHANGED_SIGNAL,
	SUDOKU_GAME_CELL_CHANGED_SIGNAL,
	SUDOKU_GAME_NUM_SIGNALS
};
static guint sudoku_game_signals[SUDOKU_GAME_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SudokuGame {
	GObject parent_instance;
	SudokuGamePrivate * priv;
	SudokuBoard* board;
	GameMode mode;
	GTimer* timer;
};

struct _SudokuGameClass {
	GObjectClass parent_class;
};

struct _SudokuGameUndoItem {
	gint row;
	gint col;
	gint val;
};

struct _SudokuGamePrivate {
	guint clock_timeout;
	gboolean _paused;
	GeeList* undostack;
	GeeList* redostack;
};

struct _Coord {
	gint row;
	gint col;
};

struct _SudokuBoard {
	GObject parent_instance;
	SudokuBoardPrivate * priv;
	gint* cells;
	gint cells_length1;
	gint cells_length2;
	gboolean* is_fixed;
	gint is_fixed_length1;
	gint is_fixed_length2;
	GeeSet* broken_coords;
	GeeList* coords_for_col;
	GeeList* coords_for_row;
	GeeMap* coords_for_block;
};

struct _SudokuBoardClass {
	GObjectClass parent_class;
};

static gint SudokuGame_private_offset;
static gpointer sudoku_game_parent_class = NULL;

GType sudoku_game_get_type (void) G_GNUC_CONST;
GType sudoku_board_get_type (void) G_GNUC_CONST;
GType game_mode_get_type (void) G_GNUC_CONST;
static GType sudoku_game_undo_item_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static SudokuGameUndoItem* sudoku_game_undo_item_dup (const SudokuGameUndoItem* self);
static void sudoku_game_undo_item_free (SudokuGameUndoItem* self);
gboolean sudoku_game_is_undostack_null (SudokuGame* self);
gboolean sudoku_game_is_redostack_null (SudokuGame* self);
SudokuGame* sudoku_game_new (SudokuBoard* board);
SudokuGame* sudoku_game_construct (GType object_type,
                                   SudokuBoard* board);
void sudoku_game_insert (SudokuGame* self,
                         gint row,
                         gint col,
                         gint val);
gint sudoku_board_get (SudokuBoard* self,
                       gint row,
                       gint col);
void sudoku_game_update_undo (SudokuGame* self,
                              gint row,
                              gint col,
                              gint old_val,
                              gint new_val);
void sudoku_board_insert (SudokuBoard* self,
                          gint row,
                          gint col,
                          gint val,
                          gboolean is_fixed);
GType coord_get_type (void) G_GNUC_CONST;
Coord* coord_dup (const Coord* self);
void coord_free (Coord* self);
void sudoku_game_remove (SudokuGame* self,
                         gint row,
                         gint col);
void sudoku_board_remove (SudokuBoard* self,
                          gint row,
                          gint col,
                          gboolean is_fixed);
gboolean sudoku_game_is_empty (SudokuGame* self);
gint sudoku_board_get_filled (SudokuBoard* self);
gboolean sudoku_board_is_empty (SudokuBoard* self);
void sudoku_game_undo (SudokuGame* self);
static void sudoku_game_apply_stack (SudokuGame* self,
                              GeeList* from,
                              GeeList* to);
void sudoku_game_redo (SudokuGame* self);
void sudoku_game_reset (SudokuGame* self);
void sudoku_board_set_previous_played_time (SudokuBoard* self,
                                            gdouble value);
gint sudoku_board_get_rows (SudokuBoard* self);
gint sudoku_board_get_cols (SudokuBoard* self);
void sudoku_game_cell_changed_cb (SudokuGame* self,
                                  gint row,
                                  gint col,
                                  gint old_val,
                                  gint new_val);
static void sudoku_game_add_to_stack (SudokuGame* self,
                               GeeList* stack,
                               gint r,
                               gint c,
                               gint v);
gdouble sudoku_game_get_total_time_played (SudokuGame* self);
gdouble sudoku_board_get_previous_played_time (SudokuBoard* self);
static gboolean sudoku_game_timeout_cb (SudokuGame* self);
static gboolean _sudoku_game_timeout_cb_gsource_func (gpointer self);
void sudoku_game_start_clock (SudokuGame* self);
void sudoku_game_stop_clock (SudokuGame* self);
static void sudoku_game_set_paused (SudokuGame* self,
                             gboolean value);
void sudoku_game_resume_clock (SudokuGame* self);
gboolean sudoku_game_get_paused (SudokuGame* self);
static void g_cclosure_user_marshal_VOID__INT_INT_INT_INT (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data);
static void sudoku_game_finalize (GObject * obj);
static void _vala_sudoku_game_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_sudoku_game_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);

static inline gpointer
sudoku_game_get_instance_private (SudokuGame* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuGame_private_offset);
}

gboolean
sudoku_game_is_undostack_null (SudokuGame* self)
{
	gboolean result = FALSE;
	GeeList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->undostack;
	_tmp1_ = gee_collection_get_size ((GeeCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_ == 0;
	return result;
}

gboolean
sudoku_game_is_redostack_null (SudokuGame* self)
{
	gboolean result = FALSE;
	GeeList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->redostack;
	_tmp1_ = gee_collection_get_size ((GeeCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_ == 0;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

SudokuGame*
sudoku_game_construct (GType object_type,
                       SudokuBoard* board)
{
	SudokuGame * self = NULL;
	SudokuBoard* _tmp0_;
	GTimer* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	g_return_val_if_fail (board != NULL, NULL);
	self = (SudokuGame*) g_object_new (object_type, NULL);
	_tmp0_ = _g_object_ref0 (board);
	_g_object_unref0 (self->board);
	self->board = _tmp0_;
	self->mode = GAME_MODE_PLAY;
	_tmp1_ = g_timer_new ();
	_g_timer_destroy0 (self->timer);
	self->timer = _tmp1_;
	_tmp2_ = gee_array_list_new (SUDOKU_GAME_TYPE_UNDO_ITEM, (GBoxedCopyFunc) sudoku_game_undo_item_dup, (GDestroyNotify) sudoku_game_undo_item_free, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->undostack);
	self->priv->undostack = (GeeList*) _tmp2_;
	_tmp3_ = gee_array_list_new (SUDOKU_GAME_TYPE_UNDO_ITEM, (GBoxedCopyFunc) sudoku_game_undo_item_dup, (GDestroyNotify) sudoku_game_undo_item_free, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->redostack);
	self->priv->redostack = (GeeList*) _tmp3_;
	return self;
}

SudokuGame*
sudoku_game_new (SudokuBoard* board)
{
	return sudoku_game_construct (TYPE_SUDOKU_GAME, board);
}

void
sudoku_game_insert (SudokuGame* self,
                    gint row,
                    gint col,
                    gint val)
{
	gint old_val = 0;
	SudokuBoard* _tmp0_;
	GameMode _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->board;
	old_val = sudoku_board_get (_tmp0_, row, col);
	sudoku_game_update_undo (self, row, col, old_val, val);
	_tmp1_ = self->mode;
	if (_tmp1_ == GAME_MODE_CREATE) {
		SudokuBoard* _tmp2_;
		SudokuBoard* _tmp3_;
		gboolean* _tmp4_;
		gint _tmp4__length1;
		gint _tmp4__length2;
		_tmp2_ = self->board;
		sudoku_board_insert (_tmp2_, row, col, val, TRUE);
		_tmp3_ = self->board;
		_tmp4_ = _tmp3_->is_fixed;
		_tmp4__length1 = _tmp3_->is_fixed_length1;
		_tmp4__length2 = _tmp3_->is_fixed_length2;
		_tmp4_[(row * _tmp4__length2) + col] = TRUE;
	} else {
		SudokuBoard* _tmp5_;
		_tmp5_ = self->board;
		sudoku_board_insert (_tmp5_, row, col, val, FALSE);
	}
	g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_CELL_CHANGED_SIGNAL], 0, row, col, old_val, val);
}

void
sudoku_game_remove (SudokuGame* self,
                    gint row,
                    gint col)
{
	gint old_val = 0;
	SudokuBoard* _tmp0_;
	GameMode _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->board;
	old_val = sudoku_board_get (_tmp0_, row, col);
	sudoku_game_update_undo (self, row, col, old_val, 0);
	_tmp1_ = self->mode;
	if (_tmp1_ == GAME_MODE_CREATE) {
		SudokuBoard* _tmp2_;
		SudokuBoard* _tmp3_;
		gboolean* _tmp4_;
		gint _tmp4__length1;
		gint _tmp4__length2;
		_tmp2_ = self->board;
		sudoku_board_remove (_tmp2_, row, col, TRUE);
		_tmp3_ = self->board;
		_tmp4_ = _tmp3_->is_fixed;
		_tmp4__length1 = _tmp3_->is_fixed_length1;
		_tmp4__length2 = _tmp3_->is_fixed_length2;
		_tmp4_[(row * _tmp4__length2) + col] = FALSE;
	} else {
		SudokuBoard* _tmp5_;
		_tmp5_ = self->board;
		sudoku_board_remove (_tmp5_, row, col, FALSE);
	}
	g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_CELL_CHANGED_SIGNAL], 0, row, col, old_val, 0);
}

gboolean
sudoku_game_is_empty (SudokuGame* self)
{
	gboolean result = FALSE;
	GameMode _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->mode;
	if (_tmp0_ == GAME_MODE_CREATE) {
		SudokuBoard* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		_tmp1_ = self->board;
		_tmp2_ = sudoku_board_get_filled (_tmp1_);
		_tmp3_ = _tmp2_;
		result = _tmp3_ == 0;
		return result;
	} else {
		SudokuBoard* _tmp4_;
		_tmp4_ = self->board;
		result = sudoku_board_is_empty (_tmp4_);
		return result;
	}
}

void
sudoku_game_undo (SudokuGame* self)
{
	GeeList* _tmp0_;
	GeeList* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->undostack;
	_tmp1_ = self->priv->redostack;
	sudoku_game_apply_stack (self, _tmp0_, _tmp1_);
}

void
sudoku_game_redo (SudokuGame* self)
{
	GeeList* _tmp0_;
	GeeList* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->redostack;
	_tmp1_ = self->priv->undostack;
	sudoku_game_apply_stack (self, _tmp0_, _tmp1_);
}

void
sudoku_game_reset (SudokuGame* self)
{
	SudokuBoard* _tmp0_;
	GTimer* _tmp1_;
	GeeList* _tmp2_;
	GeeList* _tmp3_;
	SudokuBoard* _tmp26_;
	GeeSet* _tmp27_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->board;
	sudoku_board_set_previous_played_time (_tmp0_, (gdouble) 0);
	_tmp1_ = self->timer;
	g_timer_start (_tmp1_);
	_tmp2_ = self->priv->undostack;
	gee_collection_clear ((GeeCollection*) _tmp2_);
	_tmp3_ = self->priv->redostack;
	gee_collection_clear ((GeeCollection*) _tmp3_);
	{
		gint l1 = 0;
		l1 = 0;
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				SudokuBoard* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = l1;
					l1 = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				_tmp6_ = self->board;
				_tmp7_ = sudoku_board_get_rows (_tmp6_);
				_tmp8_ = _tmp7_;
				if (!(l1 < _tmp8_)) {
					break;
				}
				{
					gint l2 = 0;
					l2 = 0;
					{
						gboolean _tmp9_ = FALSE;
						_tmp9_ = TRUE;
						while (TRUE) {
							SudokuBoard* _tmp11_;
							gint _tmp12_;
							gint _tmp13_;
							gboolean _tmp14_ = FALSE;
							GameMode _tmp15_;
							SudokuBoard* _tmp19_;
							SudokuBoard* _tmp20_;
							gboolean* _tmp21_;
							gint _tmp21__length1;
							gint _tmp21__length2;
							gboolean _tmp22_;
							SudokuBoard* _tmp23_;
							gboolean* _tmp24_;
							gint _tmp24__length1;
							gint _tmp24__length2;
							SudokuBoard* _tmp25_;
							if (!_tmp9_) {
								gint _tmp10_;
								_tmp10_ = l2;
								l2 = _tmp10_ + 1;
							}
							_tmp9_ = FALSE;
							_tmp11_ = self->board;
							_tmp12_ = sudoku_board_get_cols (_tmp11_);
							_tmp13_ = _tmp12_;
							if (!(l2 < _tmp13_)) {
								break;
							}
							_tmp15_ = self->mode;
							if (_tmp15_ == GAME_MODE_PLAY) {
								SudokuBoard* _tmp16_;
								gboolean* _tmp17_;
								gint _tmp17__length1;
								gint _tmp17__length2;
								gboolean _tmp18_;
								_tmp16_ = self->board;
								_tmp17_ = _tmp16_->is_fixed;
								_tmp17__length1 = _tmp16_->is_fixed_length1;
								_tmp17__length2 = _tmp16_->is_fixed_length2;
								_tmp18_ = _tmp17_[(l1 * _tmp17__length2) + l2];
								_tmp14_ = _tmp18_;
							} else {
								_tmp14_ = FALSE;
							}
							if (_tmp14_) {
								continue;
							}
							_tmp19_ = self->board;
							_tmp20_ = self->board;
							_tmp21_ = _tmp20_->is_fixed;
							_tmp21__length1 = _tmp20_->is_fixed_length1;
							_tmp21__length2 = _tmp20_->is_fixed_length2;
							_tmp22_ = _tmp21_[(l1 * _tmp21__length2) + l2];
							sudoku_board_remove (_tmp19_, l1, l2, _tmp22_);
							_tmp23_ = self->board;
							_tmp24_ = _tmp23_->is_fixed;
							_tmp24__length1 = _tmp23_->is_fixed_length1;
							_tmp24__length2 = _tmp23_->is_fixed_length2;
							_tmp24_[(l1 * _tmp24__length2) + l2] = FALSE;
							_tmp25_ = self->board;
							g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_CELL_CHANGED_SIGNAL], 0, l1, l2, sudoku_board_get (_tmp25_, l1, l2), 0);
						}
					}
				}
			}
		}
	}
	_tmp26_ = self->board;
	_tmp27_ = _tmp26_->broken_coords;
	gee_collection_clear ((GeeCollection*) _tmp27_);
}

void
sudoku_game_cell_changed_cb (SudokuGame* self,
                             gint row,
                             gint col,
                             gint old_val,
                             gint new_val)
{
	g_return_if_fail (self != NULL);
	g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_CELL_CHANGED_SIGNAL], 0, row, col, old_val, new_val);
}

void
sudoku_game_update_undo (SudokuGame* self,
                         gint row,
                         gint col,
                         gint old_val,
                         gint new_val)
{
	GeeList* _tmp0_;
	GeeList* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->undostack;
	sudoku_game_add_to_stack (self, _tmp0_, row, col, old_val);
	_tmp1_ = self->priv->redostack;
	gee_collection_clear ((GeeCollection*) _tmp1_);
}

static void
sudoku_game_add_to_stack (SudokuGame* self,
                          GeeList* stack,
                          gint r,
                          gint c,
                          gint v)
{
	SudokuGameUndoItem step = {0};
	SudokuGameUndoItem _tmp0_ = {0};
	SudokuGameUndoItem _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (stack != NULL);
	_tmp0_.row = r;
	_tmp0_.col = c;
	_tmp0_.val = v;
	step = _tmp0_;
	_tmp1_ = step;
	gee_collection_add ((GeeCollection*) stack, &_tmp1_);
}

static void
sudoku_game_apply_stack (SudokuGame* self,
                         GeeList* from,
                         GeeList* to)
{
	gint _tmp0_;
	gint _tmp1_;
	SudokuGameUndoItem* top = NULL;
	gint _tmp2_;
	gint _tmp3_;
	gpointer _tmp4_;
	gint old_val = 0;
	SudokuBoard* _tmp5_;
	SudokuGameUndoItem* _tmp6_;
	SudokuGameUndoItem* _tmp7_;
	SudokuGameUndoItem* _tmp8_;
	SudokuGameUndoItem* _tmp9_;
	GameMode _tmp10_;
	SudokuGameUndoItem* _tmp26_;
	SudokuGameUndoItem* _tmp45_;
	SudokuGameUndoItem* _tmp46_;
	SudokuGameUndoItem* _tmp47_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (from != NULL);
	g_return_if_fail (to != NULL);
	_tmp0_ = gee_collection_get_size ((GeeCollection*) from);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == 0) {
		return;
	}
	_tmp2_ = gee_collection_get_size ((GeeCollection*) from);
	_tmp3_ = _tmp2_;
	_tmp4_ = gee_list_remove_at (from, _tmp3_ - 1);
	top = (SudokuGameUndoItem*) _tmp4_;
	_tmp5_ = self->board;
	_tmp6_ = top;
	_tmp7_ = top;
	old_val = sudoku_board_get (_tmp5_, (*_tmp6_).row, (*_tmp7_).col);
	_tmp8_ = top;
	_tmp9_ = top;
	sudoku_game_add_to_stack (self, to, (*_tmp8_).row, (*_tmp9_).col, old_val);
	_tmp10_ = self->mode;
	if (_tmp10_ == GAME_MODE_CREATE) {
		SudokuBoard* _tmp11_;
		SudokuGameUndoItem* _tmp12_;
		SudokuGameUndoItem* _tmp13_;
		SudokuBoard* _tmp14_;
		gboolean* _tmp15_;
		gint _tmp15__length1;
		gint _tmp15__length2;
		SudokuGameUndoItem* _tmp16_;
		SudokuGameUndoItem* _tmp17_;
		gboolean _tmp18_;
		SudokuBoard* _tmp19_;
		gboolean* _tmp20_;
		gint _tmp20__length1;
		gint _tmp20__length2;
		SudokuGameUndoItem* _tmp21_;
		SudokuGameUndoItem* _tmp22_;
		_tmp11_ = self->board;
		_tmp12_ = top;
		_tmp13_ = top;
		_tmp14_ = self->board;
		_tmp15_ = _tmp14_->is_fixed;
		_tmp15__length1 = _tmp14_->is_fixed_length1;
		_tmp15__length2 = _tmp14_->is_fixed_length2;
		_tmp16_ = top;
		_tmp17_ = top;
		_tmp18_ = _tmp15_[((*_tmp16_).row * _tmp15__length2) + (*_tmp17_).col];
		sudoku_board_remove (_tmp11_, (*_tmp12_).row, (*_tmp13_).col, _tmp18_);
		_tmp19_ = self->board;
		_tmp20_ = _tmp19_->is_fixed;
		_tmp20__length1 = _tmp19_->is_fixed_length1;
		_tmp20__length2 = _tmp19_->is_fixed_length2;
		_tmp21_ = top;
		_tmp22_ = top;
		_tmp20_[((*_tmp21_).row * _tmp20__length2) + (*_tmp22_).col] = FALSE;
	} else {
		SudokuBoard* _tmp23_;
		SudokuGameUndoItem* _tmp24_;
		SudokuGameUndoItem* _tmp25_;
		_tmp23_ = self->board;
		_tmp24_ = top;
		_tmp25_ = top;
		sudoku_board_remove (_tmp23_, (*_tmp24_).row, (*_tmp25_).col, FALSE);
	}
	_tmp26_ = top;
	if ((*_tmp26_).val != 0) {
		GameMode _tmp27_;
		_tmp27_ = self->mode;
		if (_tmp27_ == GAME_MODE_CREATE) {
			SudokuBoard* _tmp28_;
			SudokuGameUndoItem* _tmp29_;
			SudokuGameUndoItem* _tmp30_;
			SudokuGameUndoItem* _tmp31_;
			SudokuBoard* _tmp32_;
			gboolean* _tmp33_;
			gint _tmp33__length1;
			gint _tmp33__length2;
			SudokuGameUndoItem* _tmp34_;
			SudokuGameUndoItem* _tmp35_;
			gboolean _tmp36_;
			SudokuBoard* _tmp37_;
			gboolean* _tmp38_;
			gint _tmp38__length1;
			gint _tmp38__length2;
			SudokuGameUndoItem* _tmp39_;
			SudokuGameUndoItem* _tmp40_;
			_tmp28_ = self->board;
			_tmp29_ = top;
			_tmp30_ = top;
			_tmp31_ = top;
			_tmp32_ = self->board;
			_tmp33_ = _tmp32_->is_fixed;
			_tmp33__length1 = _tmp32_->is_fixed_length1;
			_tmp33__length2 = _tmp32_->is_fixed_length2;
			_tmp34_ = top;
			_tmp35_ = top;
			_tmp36_ = _tmp33_[((*_tmp34_).row * _tmp33__length2) + (*_tmp35_).col];
			sudoku_board_insert (_tmp28_, (*_tmp29_).row, (*_tmp30_).col, (*_tmp31_).val, _tmp36_);
			_tmp37_ = self->board;
			_tmp38_ = _tmp37_->is_fixed;
			_tmp38__length1 = _tmp37_->is_fixed_length1;
			_tmp38__length2 = _tmp37_->is_fixed_length2;
			_tmp39_ = top;
			_tmp40_ = top;
			_tmp38_[((*_tmp39_).row * _tmp38__length2) + (*_tmp40_).col] = TRUE;
		} else {
			SudokuBoard* _tmp41_;
			SudokuGameUndoItem* _tmp42_;
			SudokuGameUndoItem* _tmp43_;
			SudokuGameUndoItem* _tmp44_;
			_tmp41_ = self->board;
			_tmp42_ = top;
			_tmp43_ = top;
			_tmp44_ = top;
			sudoku_board_insert (_tmp41_, (*_tmp42_).row, (*_tmp43_).col, (*_tmp44_).val, FALSE);
		}
	}
	_tmp45_ = top;
	_tmp46_ = top;
	_tmp47_ = top;
	g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_CELL_CHANGED_SIGNAL], 0, (*_tmp45_).row, (*_tmp46_).col, old_val, (*_tmp47_).val);
	_sudoku_game_undo_item_free0 (top);
}

gdouble
sudoku_game_get_total_time_played (SudokuGame* self)
{
	gdouble result = 0.0;
	SudokuBoard* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	GTimer* _tmp3_;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->board;
	_tmp1_ = sudoku_board_get_previous_played_time (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->timer;
	result = _tmp2_ + g_timer_elapsed (_tmp3_, NULL);
	return result;
}

static gboolean
_sudoku_game_timeout_cb_gsource_func (gpointer self)
{
	gboolean result;
	result = sudoku_game_timeout_cb ((SudokuGame*) self);
	return result;
}

static gboolean
sudoku_game_timeout_cb (SudokuGame* self)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	self->priv->clock_timeout = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 1, _sudoku_game_timeout_cb_gsource_func, g_object_ref (self), g_object_unref);
	g_source_set_name_by_id (self->priv->clock_timeout, "[gnome-sudoku] timeout_cb");
	g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_TICK_SIGNAL], 0);
	result = FALSE;
	return result;
}

void
sudoku_game_start_clock (SudokuGame* self)
{
	GTimer* _tmp0_;
	GTimer* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->timer;
	if (_tmp0_ == NULL) {
		GTimer* _tmp1_;
		_tmp1_ = g_timer_new ();
		_g_timer_destroy0 (self->timer);
		self->timer = _tmp1_;
	}
	_tmp2_ = self->timer;
	g_timer_start (_tmp2_);
	sudoku_game_timeout_cb (self);
}

void
sudoku_game_stop_clock (SudokuGame* self)
{
	GTimer* _tmp0_;
	GTimer* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->timer;
	_vala_return_if_fail (_tmp0_ != NULL, "timer != null");
	if (self->priv->clock_timeout != ((guint) 0)) {
		g_source_remove (self->priv->clock_timeout);
	}
	self->priv->clock_timeout = (guint) 0;
	sudoku_game_set_paused (self, TRUE);
	_tmp1_ = self->timer;
	g_timer_stop (_tmp1_);
	g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_TICK_SIGNAL], 0);
}

void
sudoku_game_resume_clock (SudokuGame* self)
{
	GTimer* _tmp0_;
	GTimer* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->timer;
	_vala_return_if_fail ((_tmp0_ != NULL) && (self->priv->clock_timeout == ((guint) 0)), "timer != null && clock_timeout == 0");
	_tmp1_ = self->timer;
	g_timer_continue (_tmp1_);
	sudoku_game_set_paused (self, FALSE);
	sudoku_game_timeout_cb (self);
}

gboolean
sudoku_game_get_paused (SudokuGame* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_paused;
	return result;
}

static void
sudoku_game_set_paused (SudokuGame* self,
                        gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_paused = value;
	g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_PAUSED_CHANGED_SIGNAL], 0);
	g_object_notify_by_pspec ((GObject *) self, sudoku_game_properties[SUDOKU_GAME_PAUSED_PROPERTY]);
}

static void
g_cclosure_user_marshal_VOID__INT_INT_INT_INT (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT_INT_INT) (gpointer data1, gint arg_1, gint arg_2, gint arg_3, gint arg_4, gpointer data2);
	register GMarshalFunc_VOID__INT_INT_INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 5);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__INT_INT_INT_INT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), g_value_get_int (param_values + 3), g_value_get_int (param_values + 4), data2);
}

static SudokuGameUndoItem*
sudoku_game_undo_item_dup (const SudokuGameUndoItem* self)
{
	SudokuGameUndoItem* dup;
	dup = g_new0 (SudokuGameUndoItem, 1);
	memcpy (dup, self, sizeof (SudokuGameUndoItem));
	return dup;
}

static void
sudoku_game_undo_item_free (SudokuGameUndoItem* self)
{
	g_free (self);
}

static GType
sudoku_game_undo_item_get_type (void)
{
	static volatile gsize sudoku_game_undo_item_type_id__volatile = 0;
	if (g_once_init_enter (&sudoku_game_undo_item_type_id__volatile)) {
		GType sudoku_game_undo_item_type_id;
		sudoku_game_undo_item_type_id = g_boxed_type_register_static ("SudokuGameUndoItem", (GBoxedCopyFunc) sudoku_game_undo_item_dup, (GBoxedFreeFunc) sudoku_game_undo_item_free);
		g_once_init_leave (&sudoku_game_undo_item_type_id__volatile, sudoku_game_undo_item_type_id);
	}
	return sudoku_game_undo_item_type_id__volatile;
}

static void
sudoku_game_class_init (SudokuGameClass * klass,
                        gpointer klass_data)
{
	sudoku_game_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SudokuGame_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_game_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_game_set_property;
	G_OBJECT_CLASS (klass)->finalize = sudoku_game_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_GAME_PAUSED_PROPERTY, sudoku_game_properties[SUDOKU_GAME_PAUSED_PROPERTY] = g_param_spec_boolean ("paused", "paused", "paused", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	sudoku_game_signals[SUDOKU_GAME_TICK_SIGNAL] = g_signal_new ("tick", TYPE_SUDOKU_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	sudoku_game_signals[SUDOKU_GAME_PAUSED_CHANGED_SIGNAL] = g_signal_new ("paused-changed", TYPE_SUDOKU_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	sudoku_game_signals[SUDOKU_GAME_CELL_CHANGED_SIGNAL] = g_signal_new ("cell-changed", TYPE_SUDOKU_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT_INT_INT, G_TYPE_NONE, 4, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT);
}

static void
sudoku_game_instance_init (SudokuGame * self,
                           gpointer klass)
{
	self->priv = sudoku_game_get_instance_private (self);
	self->priv->_paused = FALSE;
}

static void
sudoku_game_finalize (GObject * obj)
{
	SudokuGame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_GAME, SudokuGame);
	_g_object_unref0 (self->board);
	_g_timer_destroy0 (self->timer);
	_g_object_unref0 (self->priv->undostack);
	_g_object_unref0 (self->priv->redostack);
	G_OBJECT_CLASS (sudoku_game_parent_class)->finalize (obj);
}

GType
sudoku_game_get_type (void)
{
	static volatile gsize sudoku_game_type_id__volatile = 0;
	if (g_once_init_enter (&sudoku_game_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SudokuGameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuGame), 0, (GInstanceInitFunc) sudoku_game_instance_init, NULL };
		GType sudoku_game_type_id;
		sudoku_game_type_id = g_type_register_static (G_TYPE_OBJECT, "SudokuGame", &g_define_type_info, 0);
		SudokuGame_private_offset = g_type_add_instance_private (sudoku_game_type_id, sizeof (SudokuGamePrivate));
		g_once_init_leave (&sudoku_game_type_id__volatile, sudoku_game_type_id);
	}
	return sudoku_game_type_id__volatile;
}

static void
_vala_sudoku_game_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	SudokuGame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_GAME, SudokuGame);
	switch (property_id) {
		case SUDOKU_GAME_PAUSED_PROPERTY:
		g_value_set_boolean (value, sudoku_game_get_paused (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_sudoku_game_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	SudokuGame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_GAME, SudokuGame);
	switch (property_id) {
		case SUDOKU_GAME_PAUSED_PROPERTY:
		sudoku_game_set_paused (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

GType
game_mode_get_type (void)
{
	static volatile gsize game_mode_type_id__volatile = 0;
	if (g_once_init_enter (&game_mode_type_id__volatile)) {
		static const GEnumValue values[] = {{GAME_MODE_PLAY, "GAME_MODE_PLAY", "play"}, {GAME_MODE_CREATE, "GAME_MODE_CREATE", "create"}, {0, NULL, NULL}};
		GType game_mode_type_id;
		game_mode_type_id = g_enum_register_static ("GameMode", values);
		g_once_init_leave (&game_mode_type_id__volatile, game_mode_type_id);
	}
	return game_mode_type_id__volatile;
}

